
#ifndef __jstring_h
#define __jstring_h

#include "encoding.h"
#include "memoryreader.h"
#include "stringwriter.h"
//#include "widememoryreader.h"
#include "widestringwriter.h"
//#include <mbstring.h>
#include <string>
#include <sstream>


namespace soramimi {
	namespace encoding {

		inline std::wstring convert(encoding_t e, char const *ptr, char const *end)
		{
			memoryreader reader(ptr, end);
			widestringwriter writer;
			soramimi::encoding::reader_state_t istate;
			soramimi::encoding::setup_reader_state(&istate, e);
			soramimi::encoding::convert(&istate, &reader, &writer);
			return writer.str();
		}

		inline std::wstring convert(encoding_t e, char const *ptr, size_t len)
		{
			return convert(e, ptr, ptr + len);
		}

		inline std::wstring convert(encoding_t e, char const *ptr)
		{
			return convert(e, ptr, strlen(ptr));
		}

		inline std::wstring convert(encoding_t e, std::string const &str)
		{
			return convert(e, str.c_str(), str.size());
		}

		inline std::string convert(encoding_t e, uchar_t const *ptr, uchar_t const *end)
		{
			stringwriter writer;
			soramimi::encoding::writer_state_t ostate;
			soramimi::encoding::setup_writer_state(&ostate, e);
			soramimi::encoding::convert(&ostate, &writer, ptr, end);
			return writer.str();
		}

		inline std::string convert(encoding_t e, uchar_t const *ptr, size_t len)
		{
			return convert(e, ptr, ptr + len);
		}

		inline std::string convert(encoding_t e, uchar_t const *ptr)
		{
			return convert(e, ptr, wcslen((wchar_t const *)ptr));
		}

		inline std::string convert(encoding_t e, std::wstring const &str)
		{
			return convert(e, (uchar_t const *)str.c_str(), str.size());
		}

		//void convert(std::stringstream *out, encoding_t e, uchar_t const *ptr, uchar_t const *end);

		//inline void convert(std::stringstream *out, encoding_t e, uchar_t const *ptr, size_t len)
		//{
		//	convert(out, e, ptr, ptr + len);
		//}

		//inline void convert(std::stringstream *out, encoding_t e, uchar_t const *ptr)
		//{
		//	convert(out, e, ptr, ptr + ::text::length(ptr));
		//}

		//inline void convert(std::stringstream *out, encoding_t e, std::wstring const &str)
		//{
		//	convert(out, e, (uchar_t const *)str.c_str(), str.size());
		//}

	}
}

#endif
