
#ifndef __common__html_h
#define __common__html_h

#include <string>

//

std::wstring encode_html_entity(wchar_t const *ptr, size_t len);

inline std::wstring encode_html_entity(wchar_t const *ptr)
{
	return encode_html_entity(ptr, wcslen(ptr));
}

inline std::wstring encode_html_entity(std::wstring const &str)
{
	return encode_html_entity(str.c_str(), str.size());
}

//

std::string encode_html_entity(char const *ptr, size_t len);

inline std::string encode_html_entity(char const *ptr)
{
	return encode_html_entity(ptr, strlen(ptr));
}

inline std::string encode_html_entity(std::string const &str)
{
	return encode_html_entity(str.c_str(), str.size());
}

//

std::wstring decode_html_entity(wchar_t const *ptr, size_t len);

inline std::wstring decode_html_entity(wchar_t const *ptr)
{
	return decode_html_entity(ptr, wcslen(ptr));
}

inline std::wstring decode_html_entity(std::wstring const &str)
{
	return decode_html_entity(str.c_str(), str.size());
}

//

std::string decode_html_entity(char const *ptr, size_t len);

inline std::string decode_html_entity(char const *ptr)
{
	return decode_html_entity(ptr, strlen(ptr));
}

inline std::string decode_html_entity(std::string const &str)
{
	return decode_html_entity(str.c_str(), str.size());
}



#endif
