
#ifndef __thread_h
#define __thread_h

#ifdef WIN32
	#include <windows.h>
	#include <process.h>
#else
	#include <pthread.h>
#endif



class Thread {
protected:
	bool _interrupted;
	bool _running;
#ifdef WIN32
	HANDLE _thread_handle;
	static unsigned int __stdcall run_(void *arg)
	{
		Thread *me = (Thread *)arg;
		me->run();
		return 0;
	}
#else
	pthread_t _thread_handle;
	static void *run_(void *arg)
	{
		Thread *me = (Thread *)arg;
		me->run();
		return 0;
	}
#endif

public:
	Thread()
	{
		_interrupted = false;
		_running = false;
	}
	virtual ~Thread()
	{
		close();
	}
protected:
	virtual void run() = 0;
public:
	bool interrupted() const
	{
		return _interrupted;
	}
	virtual void start();
	virtual void stop();
	virtual void join();
	virtual void close();
};



#endif
